Bug 1123645 - Review Request: mingw-libgee - GObject collection library
Summary: Review Request: mingw-libgee - GObject collection library
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: David King
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-27 14:16 UTC by Marc-Andre Lureau
Modified: 2016-08-14 15:29 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
amigadave: fedora-review+


Attachments (Terms of Use)

Description Marc-Andre Lureau 2014-07-27 14:16:15 UTC
Spec URL: http://elmarco.fedorapeople.org/mingw-libgee.spec
SRPM URL: http://elmarco.fedorapeople.org/mingw-libgee-0.15.3-1.fc20.src.rpm
Description: GObject collection library
Fedora Account System Username: elmarco

Comment 1 David King 2014-08-01 19:06:02 UTC
Package Review
==============

Approved. A couple of trivial fixes would be nice:

* Homepage could be updated to https://wiki.gnome.org/Projects/Libgee
* add INSTALL="install -p" to the make install invocation to preserve some more timestamps

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Header files in -devel subpackage, if present.
  Note: mingw32-libgee : /usr/i686-w64-mingw32/sys-
  root/mingw/include/gee-0.8/gee.h mingw64-libgee : /usr/x86_64-w64-mingw32
  /sys-root/mingw/include/gee-0.8/gee.h
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

Not a problem for mingw packages.

- Static libraries in -static or -devel subpackage, providing -devel if
  present.
  Note: Package has .a files: mingw32-libgee, mingw64-libgee. Illegal package
  name: mingw32-libgee, mingw64-libgee. Does not provide -static:
  mingw32-libgee, mingw64-libgee.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

Also not a problem for mingw packages.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2.1 or later)", "GPL (v2 or later)", "Unknown or generated". 115
     files have unknown license. Detailed output of licensecheck in
     /home/david/checkout/rpms/1123645-mingw-libgee/licensecheck.txt

Not a problem, the GPLv2 is the libtool script.

[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 163840 bytes in 12 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     mingw32-libgee , mingw64-libgee
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
     Note: mingw64-libgee : /usr/x86_64-w64-mingw32/sys-
     root/mingw/lib/pkgconfig/gee-0.8.pc mingw32-libgee :
     /usr/i686-w64-mingw32/sys-root/mingw/lib/pkgconfig/gee-0.8.pc
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define release_version %(echo
     %{version} | awk -F. '{print $1"."$2}')
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: mingw32-libgee-0.15.3-1.fc22.noarch.rpm
          mingw64-libgee-0.15.3-1.fc22.noarch.rpm
          mingw-libgee-0.15.3-1.fc22.src.rpm
mingw32-libgee.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw32-libgee.noarch: W: devel-file-in-non-devel-package /usr/i686-w64-mingw32/sys-root/mingw/include/gee-0.8/gee.h
mingw32-libgee.noarch: W: devel-file-in-non-devel-package /usr/i686-w64-mingw32/sys-root/mingw/lib/pkgconfig/gee-0.8.pc
mingw32-libgee.noarch: W: file-not-utf8 /usr/share/doc/mingw32-libgee/ChangeLog
mingw32-libgee.noarch: W: devel-file-in-non-devel-package /usr/i686-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw32-libgee.noarch: W: spurious-executable-perm /usr/i686-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw32-libgee.noarch: W: non-standard-dir-in-usr i686-w64-mingw32
mingw64-libgee.noarch: E: arch-independent-package-contains-binary-or-object /usr/x86_64-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw64-libgee.noarch: W: devel-file-in-non-devel-package /usr/x86_64-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw64-libgee.noarch: W: spurious-executable-perm /usr/x86_64-w64-mingw32/sys-root/mingw/lib/libgee-0.8.dll.a
mingw64-libgee.noarch: W: file-not-utf8 /usr/share/doc/mingw64-libgee/ChangeLog
mingw64-libgee.noarch: W: devel-file-in-non-devel-package /usr/x86_64-w64-mingw32/sys-root/mingw/lib/pkgconfig/gee-0.8.pc
mingw64-libgee.noarch: W: devel-file-in-non-devel-package /usr/x86_64-w64-mingw32/sys-root/mingw/include/gee-0.8/gee.h
mingw64-libgee.noarch: W: non-standard-dir-in-usr x86_64-w64-mingw32
3 packages and 0 specfiles checked; 2 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint mingw64-libgee mingw32-libgee
mingw64-libgee.noarch: W: file-not-utf8 /usr/share/doc/mingw64-libgee/ChangeLog
mingw32-libgee.noarch: W: file-not-utf8 /usr/share/doc/mingw32-libgee/ChangeLog
2 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/david/checkout/rpms/1123645-mingw-libgee/srpm/mingw-libgee.spec	2014-08-01 19:49:40.765519476 +0100
+++ /home/david/checkout/rpms/1123645-mingw-libgee/srpm-unpacked/mingw-libgee.spec	2014-07-27 15:08:06.000000000 +0100
@@ -22,6 +22,4 @@
 BuildRequires:  mingw32-binutils
 BuildRequires:  mingw64-binutils
-BuildRequires:  mingw32-glib2
-BuildRequires:  mingw64-glib2
 
 %description
@@ -29,4 +27,39 @@
 classes for commonly used data structures.
 
+* Traversable
+  o Iterable
+    + Collection
+      - List
+        * BidirList
+      - Set
+        * SortedSet
+          o BidirSortedSet
+      - MultiSet
+      - Queue
+        * Deque
+    + Map
+      - SortedMap
+        * BidirSortedMap
+  o Iterator
+    + BidirIterator
+      - BidirListIterator
+    + ListIterator
+      - BidirListIterator
+* MultiMap
+
+The ArrayList, ArrauQueue, ConcurrentLinkedList, ConcurrentSet, HashSet,
+HashMap, HashMultiSet, HashMultiMap, LinkedList, PriorityQueue, TreeSet,
+TreeMap, TreeMultiSet, and TreeMultiMap classes provide a reasonable sample
+implementation of those interfaces. In addition, a set of abstract
+classes are provided to ease the implementation of new collections.
+
+Around that, the API provide means to retrieve read-only views,
+efficient sort algorithms, simple, bi-directional or index-based mutable
+iterators depending on the collection type.
+
+Libgee is written in Vala and can be used like any GObject-based C
+library. It's planned to provide bindings for further languages.
+
+
 %package -n mingw32-libgee
 Summary:        MinGW GObject collection library
@@ -39,4 +72,5 @@
 This package contains the MinGW Windows cross compiled libgee library.
 
+
 %package -n mingw64-libgee
 Summary:        MinGW GObject collection library


Requires
--------
mingw64-libgee (rpmlib, GLIBC filtered):
    mingw64(kernel32.dll)
    mingw64(libgio-2.0-0.dll)
    mingw64(libglib-2.0-0.dll)
    mingw64(libgobject-2.0-0.dll)
    mingw64(msvcrt.dll)
    mingw64-crt
    mingw64-filesystem
    mingw64-pkg-config
    pkgconfig

mingw32-libgee (rpmlib, GLIBC filtered):
    mingw32(kernel32.dll)
    mingw32(libgio-2.0-0.dll)
    mingw32(libglib-2.0-0.dll)
    mingw32(libgobject-2.0-0.dll)
    mingw32(msvcrt.dll)
    mingw32-crt
    mingw32-filesystem
    mingw32-pkg-config
    pkgconfig



Provides
--------
mingw64-libgee:
    mingw64(libgee-0.8-2.dll)
    mingw64-libgee

mingw32-libgee:
    mingw32(libgee-0.8-2.dll)
    mingw32-libgee



Source checksums
----------------
http://download.gnome.org/sources/libgee/0.15/libgee-0.15.3.tar.xz :
  CHECKSUM(SHA256) this package     : 1c84dc4e0e64af4e628309c94180fbaf9a743ab045c46cb61702c39b25f1b6d4
  CHECKSUM(SHA256) upstream package : 1c84dc4e0e64af4e628309c94180fbaf9a743ab045c46cb61702c39b25f1b6d4


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 1123645
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Upstream Release Monitoring 2015-09-24 15:05:22 UTC
jgrulich's scratch build of kdevelop?#c8e2b9bc57f11e41f3dc6612cdbcc591078d9062 for f22-candidate and git://pkgs.fedoraproject.org/kdevelop?#c8e2b9bc57f11e41f3dc6612cdbcc591078d9062 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11212117


Note You need to log in before you can comment on or make changes to this bug.